package gomod

import (
	"fmt"
	"html/template"
	"net/http"
)
func Index(w http.ResponseWriter, r *http.Request) {
	r.ParseForm()
	t, err := template.ParseFiles("src/payease_icccashier/view/index.html")
	if err != nil {
		fmt.Fprintf(w, "parse template error: %s", err.Error())
		return
	}
	t.Execute(w, nil)
}
//======================================外卡收银台收单======================================================
func Order(w http.ResponseWriter, r *http.Request) {
	if r.Method == "GET" {
		t, err := template.ParseFiles("src/payease_icccashier/view/icccashier/cashierOrder.html")
		if err != nil {
			fmt.Fprintf(w, "parse template error: %s", err.Error())
			return
		}
		t.Execute(w, nil)
	} else {
		OrderRequest(w,r)
	}
}

func Callback(w http.ResponseWriter, r *http.Request) {
	OrderCallback(w,r) 
}

func Notify(w http.ResponseWriter, r *http.Request) {
	OrderNotify(w,r) 
}

func Query(w http.ResponseWriter, r *http.Request) {
	if r.Method == "GET" {
		t, err := template.ParseFiles("src/payease_icccashier/view/icccashier/query.html")
		if err != nil {
			fmt.Fprintf(w, "parse template error: %s", err.Error())
			return
		}
		t.Execute(w, nil)
	}else{
		QueryRequest(w,r)
	}
}
//退款提交
func Refund(w http.ResponseWriter, r *http.Request) {
	if r.Method == "GET" {
		t, err := template.ParseFiles("src/payease_icccashier/view/icccashier/refund.html")
		if err != nil {
			fmt.Fprintf(w, "parse template error: %s", err.Error())
			return
		}
		t.Execute(w, nil)
	}else{
		RefundRequest(w,r)
	}
}
//退款异步通知
func RefundNotify(w http.ResponseWriter, r *http.Request) {
	RefundNotifyResponse(w,r) 
}
//退款查询
func RefundQuery(w http.ResponseWriter, r *http.Request) {
	if r.Method == "GET" {
		t, err := template.ParseFiles("src/payease_icccashier/view/icccashier/refundQuery.html")
		if err != nil {
			fmt.Fprintf(w, "parse template error: %s", err.Error())
			return
		}
		t.Execute(w, nil)
	}else{
		RefundQueryRequest(w,r)
	}
}
//拒付异步通知
func RefuseNotify(w http.ResponseWriter, r *http.Request) {
	RefuseNotifyResponse(w,r) 
}
//模拟异步通知POST数据
func DataPost(w http.ResponseWriter, r *http.Request) {
	if r.Method == "GET" {
		t, err := template.ParseFiles("src/payease_icccashier/view/post.html")
		if err != nil {
			fmt.Fprintf(w, "parse template error: %s", err.Error())
			return
		}
		t.Execute(w, nil)
	}else{
		PostRequest(w,r)
	}
}