package gomod

import (
//	"io"
	"fmt"
	"net/http"
	"io/ioutil"
	"path/filepath"
	"encoding/json"
	"payease_icccashier/models"
	"payease_icccashier/utils"
)

func OrderRequest(w http.ResponseWriter, r *http.Request) {
	//接口地址
	 apiurl := "https://apis.5upay.com/icc/order"
	 //pfx私钥
	 privatepfxpath, pfxerr := filepath.Abs("src/payease_icccashier/package/client.pfx")
	 if pfxerr != nil {  
	    fmt.Println("pfxerr:", pfxerr)  
	 } 
	 pfxpwd := "123456"
     //cer公钥
	 publiccerpath, cererr := filepath.Abs("src/payease_icccashier/package/payease.cer")
	 if cererr != nil {  
	    fmt.Println("cererr:", cererr)  
	 } 
     var aesKeyValue string  = utils.GetRandomString(16)
	 r.ParseForm()
	 var orderType = utils.IsNull(r.Form["orderType"])
	 var payorder models.PayOrder
	 payorder.MerchantId = utils.IsNull(r.Form["merchantId"])
     payorder.OrderAmount = utils.IsNull(r.Form["orderAmount"])
     payorder.OrderCurrency = utils.IsNull(r.Form["orderCurrency"])
     payorder.RequestId = utils.IsNull(r.Form["requestId"])
     payorder.NotifyUrl = utils.IsNull(r.Form["notifyUrl"])
     payorder.CallbackUrl = utils.IsNull(r.Form["callbackUrl"])
     if(orderType == "RISK_SHIP" || orderType == "RISK_SHIP_BILL"){
     	var si models.ShipInfo
		si.ShipStreet = utils.IsNull(r.Form["shipStreet"])  
	    si.ShipCity = utils.IsNull(r.Form["shipCity"])
	    si.ShipState = utils.IsNull(r.Form["shipState"])
	    si.ShipPost = utils.IsNull(r.Form["shipPost"])
	    si.ShipCountry = utils.IsNull(r.Form["shipCountry"])
	    si.ShipPhone = utils.IsNull(r.Form["shipPhone"])
	    si.ShipEmail = utils.IsNull(r.Form["shipEmail"])
		payorder.ShipInfo=si
     }
     if(orderType == "RISK_BILL" || orderType == "RISK_SHIP_BILL"){
	     var bi models.BillInfo
		 bi.BillStreet = utils.IsNull(r.Form["billStreet"])  
	     bi.BillCity = utils.IsNull(r.Form["billCity"])
	     bi.BillState = utils.IsNull(r.Form["billState"])
	     bi.BillPost = utils.IsNull(r.Form["billPost"])
	     bi.BillCountry = utils.IsNull(r.Form["billCountry"])
	     bi.BillPhone = utils.IsNull(r.Form["billPhone"])
	     bi.BillEmail = utils.IsNull(r.Form["billEmail"])
		 payorder.BillInfo=bi
      }
     payorder.TerminalNo = utils.IsNull(r.Form["terminalNo"])
     payorder.Remark = utils.IsNull(r.Form["remark"])
	 //把订单对象数据转JSON字符串
	 orderdata, err := json.Marshal(payorder)  
	if err != nil {  
	    fmt.Printf(err.Error())  
	    return  
	}
	//fmt.Println("orderdata:", string(orderdata))  
	sortdata, oerr := utils.GetMapSortJson(string(orderdata))
	if oerr != nil {
        fmt.Println("oerr:", oerr)
    }
	//fmt.Println("sortdata:", sortdata) 
	hm := utils.Sha1(sortdata)
	hmac,err := utils.Sign(hm,privatepfxpath,pfxpwd)
	if err != nil {
        fmt.Println("err:", err)
    } 
	payorder.Hmac = hmac
	orderjson, err := json.Marshal(payorder)  
	if err != nil {  
	    fmt.Printf(err.Error())  
	    return  
	}
	encryptKey,enerr := utils.PublicEncrypt(aesKeyValue, publiccerpath)
	if enerr != nil {
        fmt.Println("err:", enerr)
    } 
	aesdata,aeserro := utils.AesECBEncrypt(string(orderjson), aesKeyValue)
	//fmt.Println("aesdata:", aesdata)
	if aeserro != nil {
        fmt.Println("err:", aeserro)
    } 
	response, rperr := utils.Post(apiurl,encryptKey,payorder.MerchantId,payorder.RequestId,aesdata,privatepfxpath,pfxpwd)
	if rperr != nil {
        fmt.Println("rperr:", rperr)
    } 
	var orderback models.PayOrderBack
    json.Unmarshal([]byte(response), &orderback)
    rhmac := orderback.Hmac
    //fmt.Println("rhmac:", rhmac)
    if 	rhmac != ""{
    	sortdeldata, oerr := utils.GetDelJson(string(response),"hmac")
		if oerr != nil {
	        fmt.Println("oerr:", oerr)
	    } 
		signhm := utils.Sha1(sortdeldata)
    	verr := utils.VerifySign(signhm ,publiccerpath,rhmac)
    	if verr == nil {
    		status := orderback.Status
    		if status == "SUCCESS"{
    			http.Redirect(w,r, orderback.RedirectUrl, http.StatusFound)
				return 
    		}else{
    			fmt.Println("失败:", status)
    			fmt.Fprintf(w,"失败:"+response)
    		}
    	}else{
	    	fmt.Println("verr:", verr)
	    	fmt.Fprintf(w,"验签异常!")
    	}
    }else{
    	fmt.Println("response:", response)
    	fmt.Fprintf(w, response)
    }
}

//同步返回内容处理
func OrderCallback(w http.ResponseWriter, r *http.Request) {
	 //pfx私钥
	 privatepfxpath, pfxerr := filepath.Abs("src/payease_icccashier/package/client.pfx")
	 if pfxerr != nil {  
	    fmt.Println("pfxerr:", pfxerr)  
	 } 
	 pfxpwd := "123456"
     //cer公钥
	 publiccerpath, cererr := filepath.Abs("src/payease_icccashier/package/payease.cer")
	 if cererr != nil {  
	    fmt.Println("cererr:", cererr)  
	 }
	 r.ParseForm()
	 rpencryptKey := utils.IsNull(r.Header["Encryptkey"])
     if rpencryptKey != "" {		
		aeskey,err := utils.PrivateDecrypt(rpencryptKey, privatepfxpath, pfxpwd)
		if err != nil {
		  fmt.Println("perr:", err)
	   }	
		body, err := ioutil.ReadAll(r.Body)
	   if err != nil {
	     fmt.Println("berr:", err)
	   }  
	   var rback utils.ResponseBack
       json.Unmarshal(body, &rback)
	   ret,err := utils.AesECBDecrypt(rback.Data,aeskey)
	   if err != nil {
		  fmt.Println("aerr:", err)
	   }
	   var orderbacks models.PayOrderBacks
		json.Unmarshal([]byte(ret), &orderbacks)
		rhmac := orderbacks.Hmac
		//fmt.Println("rhmac:", rhmac)
		if 	rhmac != ""{
			sortdeldata, oerr := utils.GetDelJson(string(ret),"hmac")
			if oerr != nil {
				fmt.Println("oerr:", oerr)
			} 
			signhm := utils.Sha1(sortdeldata)
			verr := utils.VerifySign(signhm ,publiccerpath,rhmac)
			//需要加入返回金额与下单金额进行比较，是否一致，以免金额被篡改
			if verr == nil {
				pstatus := orderbacks.Pstatus
				fmt.Println("支付状态:", pstatus)
				fmt.Println("ret:", ret)
				fmt.Fprintf(w,"支付状态:"+pstatus)
				fmt.Fprintf(w,"ret:"+ret)
			}else{
				fmt.Println("verr:", verr)
			}
		}else{
			fmt.Println("response:", ret)
		}
	}else{
		fmt.Println("NO Data")
	}  
	 return
}
//异步返回内容处理
func OrderNotify(w http.ResponseWriter, r *http.Request) {
	 //pfx私钥
	 privatepfxpath, pfxerr := filepath.Abs("src/payease_icccashier/package/client.pfx")
	 if pfxerr != nil {  
	    fmt.Println("pfxerr:", pfxerr)  
	 } 
	 pfxpwd := "123456"
     //cer公钥
	 publiccerpath, cererr := filepath.Abs("src/payease_icccashier/package/payease.cer")
	 if cererr != nil {  
	    fmt.Println("cererr:", cererr)  
	 }
	 r.ParseForm()
	 rpencryptKey := utils.IsNull(r.Header["Encryptkey"])
     if rpencryptKey != "" {		
		aeskey,err := utils.PrivateDecrypt(rpencryptKey, privatepfxpath, pfxpwd)
		if err != nil {
		  fmt.Println("perr:", err)
	   }	
		body, err := ioutil.ReadAll(r.Body)
	   if err != nil {
	     fmt.Println("berr:", err)
	   }  
	   var rback utils.ResponseBack
       json.Unmarshal(body, &rback)
	   ret,err := utils.AesECBDecrypt(rback.Data,aeskey)
	   if err != nil {
		  fmt.Println("aerr:", err)
	   }
	   var orderbacks models.PayOrderBacks
		json.Unmarshal([]byte(ret), &orderbacks)
		rhmac := orderbacks.Hmac
		//fmt.Println("rhmac:", rhmac)
		if 	rhmac != ""{
			sortdeldata, oerr := utils.GetDelJson(string(ret),"hmac")
			if oerr != nil {
				fmt.Println("oerr:", oerr)
			} 
			signhm := utils.Sha1(sortdeldata)
			verr := utils.VerifySign(signhm ,publiccerpath,rhmac)
			//需要加入返回金额与下单金额进行比较，是否一致，以免金额被篡改
			if verr == nil {
				pstatus := orderbacks.Pstatus
				if pstatus == "SUCCESS"{
					fmt.Fprintf(w, "SUCCESS")
					fmt.Println("SUCCESS")
					fmt.Println("处理成功!")
					fmt.Println("ret:", ret)
				}else{
					fmt.Println("处理异常:", pstatus)
					fmt.Println("ret:", ret)
				}
			}else{
				fmt.Println("verr:", verr)
			}
		}else{
			fmt.Println("response:", ret)
		}
	}else{
		fmt.Println("NO Data")
	}  
	 return
}

//订单查询请求
func QueryRequest(w http.ResponseWriter, r *http.Request) {
	 //接口地址
	 apiurl := "https://apis.5upay.com/icc/orderQuery"
	 //pfx私钥
	 privatepfxpath, pfxerr := filepath.Abs("src/payease_icccashier/package/client.pfx")
	 if pfxerr != nil {  
	    fmt.Println("pfxerr:", pfxerr)  
	 } 
	 pfxpwd := "123456"
     //cer公钥
	 publiccerpath, cererr := filepath.Abs("src/payease_icccashier/package/payease.cer")
	 if cererr != nil {  
	    fmt.Println("cererr:", cererr)  
	 } 
     var aesKeyValue string  = utils.GetRandomString(16)
	 r.ParseForm()
	 var queryorder models.QueryOrder
	 queryorder.MerchantId = utils.IsNull(r.Form["merchantId"])
	 queryorder.RequestId = utils.IsNull(r.Form["requestId"])
	  //把订单对象数据转JSON字符串
	 orderdata, err := json.Marshal(queryorder)  
	//fmt.Println("orderdata:", string(orderdata))
	if err != nil {  
	    fmt.Printf(err.Error())  
	    return  
	}  
	sortdata, oerr := utils.GetMapSortJson(string(orderdata))
	//fmt.Println("sortdata:", sortdata)
	if oerr != nil {
        fmt.Println("oerr:", oerr)
    } 
	hm := utils.Sha1(sortdata)
	hmac,err := utils.Sign(hm,privatepfxpath,pfxpwd)
	//fmt.Println("hmac:", hmac)
	if err != nil {
        fmt.Println("err:", err)
    } 
	queryorder.Hmac = hmac
	orderjson, err := json.Marshal(queryorder)  
	//fmt.Println("orderjson:", string(orderjson))
	if err != nil {  
	    fmt.Printf(err.Error())  
	    return  
	}
	encryptKey,enerr := utils.PublicEncrypt(aesKeyValue, publiccerpath)
	if enerr != nil {
        fmt.Println("err:", enerr)
    } 
	aesdata,aeserro := utils.AesECBEncrypt(string(orderjson), aesKeyValue)
	//fmt.Println("aesdata:", aesdata)
	if aeserro != nil {
        fmt.Println("err:", aeserro)
    } 
	response, rperr := utils.Post(apiurl,encryptKey,queryorder.MerchantId,queryorder.RequestId,aesdata,privatepfxpath,pfxpwd)
	if rperr != nil {
        fmt.Println("rperr:", rperr)
    } 
	var queryorderback models.QueryOrderBack
    json.Unmarshal([]byte(response), &queryorderback)
    rhmac := queryorderback.Hmac
    //fmt.Println("queryorder:", queryorderback)
    if 	rhmac != ""{
    	sortdeldata, oerr := utils.GetDelJson(string(response),"hmac")
		if oerr != nil {
	        fmt.Println("oerr:", oerr)
	    } 
		signhm := utils.Sha1(sortdeldata)
    	verr := utils.VerifySign(signhm ,publiccerpath,rhmac)
    	if verr == nil {
    		status := queryorderback.Status
    		if status == "SUCCESS"{
    			fmt.Fprintf(w, "订单查询成功！\n"+ response)
    		}else{
    			//fmt.Println("异常:", response)
    			fmt.Fprintf(w, "订单查询异常\n"+ response)
    		}
    	}else{
	    	fmt.Println("verr:", verr)
    	}
    }else{
    	fmt.Println("response:", response)
    }
}
//订单退款请求
func RefundRequest(w http.ResponseWriter, r *http.Request) {
	 //接口地址
	 apiurl := "https://apis.5upay.com/icc/refund"
	 //pfx私钥
	 privatepfxpath, pfxerr := filepath.Abs("src/payease_icccashier/package/client.pfx")
	 if pfxerr != nil {  
	    fmt.Println("pfxerr:", pfxerr)  
	 } 
	 pfxpwd := "123456"
     //cer公钥
	 publiccerpath, cererr := filepath.Abs("src/payease_icccashier/package/payease.cer")
	 if cererr != nil {  
	    fmt.Println("cererr:", cererr)  
	 } 
     var aesKeyValue string  = utils.GetRandomString(16)
	 r.ParseForm()
	 var refundorder models.RefundOrder
	 refundorder.MerchantId = utils.IsNull(r.Form["merchantId"])
	 refundorder.OrderRequestId = utils.IsNull(r.Form["orderRequestId"])
	 refundorder.RequestId = utils.IsNull(r.Form["requestId"])
	 refundorder.Amount = utils.IsNull(r.Form["amount"])     
     refundorder.NotifyUrl = utils.IsNull(r.Form["notifyUrl"])
     refundorder.Remark = utils.IsNull(r.Form["remark"])
	  //把订单对象数据转JSON字符串
	 orderdata, err := json.Marshal(refundorder)  
	if err != nil {  
	     fmt.Println("err:", err) 
	    return  
	}  
	sortdata, oerr := utils.GetMapSortJson(string(orderdata))
	if oerr != nil {
        fmt.Println("oerr:", oerr)
    } 
	hm := utils.Sha1(sortdata)
	hmac,err := utils.Sign(hm,privatepfxpath,pfxpwd)
	if err != nil {
        fmt.Println("err:", err)
    } 
	refundorder.Hmac = hmac
	orderjson, err := json.Marshal(refundorder)  
	if err != nil {  
	    fmt.Printf(err.Error())  
	    return  
	}
	encryptKey,enerr := utils.PublicEncrypt(aesKeyValue, publiccerpath)
	if enerr != nil {
        fmt.Println("err:", enerr)
    } 
	aesdata,aeserro := utils.AesECBEncrypt(string(orderjson), aesKeyValue)
	//fmt.Println("aesdata:", aesdata)
	if aeserro != nil {
        fmt.Println("err:", aeserro)
    } 
	response, rperr := utils.Post(apiurl,encryptKey,refundorder.MerchantId,refundorder.RequestId,aesdata,privatepfxpath,pfxpwd)
	if rperr != nil {
        fmt.Println("rperr:", rperr)
    } 
	var refunorderback models.RefundOrderBack
    json.Unmarshal([]byte(response), &refunorderback)
    rhmac := refunorderback.Hmac
    if 	rhmac != ""{
    	sortdeldata, oerr := utils.GetDelJson(string(response),"hmac")
		if oerr != nil {
	        fmt.Println("oerr:", oerr)
	    } 
		signhm := utils.Sha1(sortdeldata)
    	verr := utils.VerifySign(signhm ,publiccerpath,rhmac)
    	if verr == nil {
    		status := refunorderback.Status
    		if status == "SUCCESS"{
    			fmt.Println("提交成功:", response)
    			fmt.Fprintf(w, "退款提交成功\n"+ response)
    		}else{
    			fmt.Println("提交异常:", response)
    			fmt.Fprintf(w, "退款提交异常\n"+ response)
    		}
    	}else{
	    	fmt.Println("verr:", verr)
    	}
    }else{
    	fmt.Println("response:", response)
    	fmt.Fprintf(w, "退款异常\n"+ response)
    }
}
//退款异步返回内容处理
func RefundNotifyResponse(w http.ResponseWriter, r *http.Request) {
	 //pfx私钥
	 privatepfxpath, pfxerr := filepath.Abs("src/payease_icccashier/package/client.pfx")
	 if pfxerr != nil {  
	    fmt.Println("pfxerr:", pfxerr)  
	 } 
	 pfxpwd := "123456"
     //cer公钥
	 publiccerpath, cererr := filepath.Abs("src/payease_icccashier/package/payease.cer")
	 if cererr != nil {  
	    fmt.Println("cererr:", cererr)  
	 }
	 r.ParseForm()
	 rpencryptKey := utils.IsNull(r.Header["Encryptkey"])
     if rpencryptKey != "" {		
		aeskey,err := utils.PrivateDecrypt(rpencryptKey, privatepfxpath, pfxpwd)
		if err != nil {
		  fmt.Println("perr:", err)
	   }	
		body, err := ioutil.ReadAll(r.Body)
	   if err != nil {
	     fmt.Println("berr:", err)
	   }  
	   var rback utils.ResponseBack
       json.Unmarshal(body, &rback)
	   ret,err := utils.AesECBDecrypt(rback.Data,aeskey)
	   if err != nil {
		  fmt.Println("aerr:", err)
	   }
	   var orderbacks models.RefundOrderBacks
		json.Unmarshal([]byte(ret), &orderbacks)
		rhmac := orderbacks.Hmac
		//fmt.Println("rhmac:", rhmac)
		if 	rhmac != ""{
			sortdeldata, oerr := utils.GetDelJson(string(ret),"hmac")
			if oerr != nil {
				fmt.Println("oerr:", oerr)
			} 
			signhm := utils.Sha1(sortdeldata)
			verr := utils.VerifySign(signhm ,publiccerpath,rhmac)
			if verr == nil {
				status := orderbacks.RefundStatus
				if status == "SUCCESS"{
					fmt.Fprintf(w, "SUCCESS")
					fmt.Println("SUCCESS")
					fmt.Println("退款成功!")
					fmt.Println("ret:", ret)
				}else{
					fmt.Println("退款异常:", status)
					fmt.Println("ret:", ret)
				}
			}else{
				fmt.Println("verr:", verr)
			}
		}else{
			fmt.Println("response:", ret)
			fmt.Fprintf(w, "退款异常\n"+ ret)
		}
	}else{
		fmt.Println("NO Data")
	}  
	 return
}
//退款订单查询请求
func RefundQueryRequest(w http.ResponseWriter, r *http.Request) {
	 r.ParseForm()
	 //接口地址
	 apiurl := "https://apis.5upay.com/icc/refundQuery"
	 //pfx私钥
	 privatepfxpath, pfxerr := filepath.Abs("src/payease_icccashier/package/client.pfx")
	 if pfxerr != nil {  
	    fmt.Println("pfxerr:", pfxerr)  
	 } 
	 pfxpwd := "123456"
     //cer公钥
	 publiccerpath, cererr := filepath.Abs("src/payease_icccashier/package/payease.cer")
	 if cererr != nil {  
	    fmt.Println("cererr:", cererr)  
	 } 
     var aesKeyValue string  = utils.GetRandomString(16)
	 r.ParseForm()
	 var queryorder models.QueryRefund
	 queryorder.MerchantId = utils.IsNull(r.Form["merchantId"])
	 queryorder.RequestId = utils.IsNull(r.Form["requestId"])
	  //把订单对象数据转JSON字符串
	 orderdata, err := json.Marshal(queryorder)  
	if err != nil {  
	    fmt.Printf(err.Error())  
	    return  
	}  
	sortdata, oerr := utils.GetMapSortJson(string(orderdata))
	if oerr != nil {
        fmt.Println("oerr:", oerr)
    } 
	hm := utils.Sha1(sortdata)
	hmac,err := utils.Sign(hm,privatepfxpath,pfxpwd)
	if err != nil {
        fmt.Println("err:", err)
    } 
	queryorder.Hmac = hmac
	orderjson, err := json.Marshal(queryorder)  
	if err != nil {  
	    fmt.Printf(err.Error())  
	    return  
	}
	encryptKey,enerr := utils.PublicEncrypt(aesKeyValue, publiccerpath)
	if enerr != nil {
        fmt.Println("err:", enerr)
    } 
	aesdata,aeserro := utils.AesECBEncrypt(string(orderjson), aesKeyValue)
	//fmt.Println("aesdata:", aesdata)
	if aeserro != nil {
        fmt.Println("err:", aeserro)
    } 
	response, rperr := utils.Post(apiurl,encryptKey,queryorder.MerchantId,queryorder.RequestId,aesdata,privatepfxpath,pfxpwd)
	if rperr != nil {
        fmt.Println("rperr:", rperr)
    }  
	var refunorderback models.QueryRefundBack
    json.Unmarshal([]byte(response), &refunorderback)
    rhmac := refunorderback.Hmac
    if 	rhmac != ""{
    	sortdeldata, oerr := utils.GetDelJson(string(response),"hmac")
		if oerr != nil {
	        fmt.Println("oerr:", oerr)
	    } 
		signhm := utils.Sha1(sortdeldata)
    	verr := utils.VerifySign(signhm ,publiccerpath,rhmac)
    	if verr == nil {
    		status := refunorderback.Status
    		if status == "SUCCESS"{
    			//fmt.Println("退款成功:", response)
    			fmt.Fprintf(w, "退款查询成功\n"+ response)
    		}else{
    			//fmt.Println("退款异常:", response)
    			fmt.Fprintf(w, "退款查询异常\n"+ response)
    		}
    	}else{
	    	fmt.Println("verr:", verr)
    	}
    }else{
    	fmt.Println("response:", response)
    	fmt.Fprintf(w, "退款查询异常\n"+ response)
    }
}
//拒付异步返回内容处理
func RefuseNotifyResponse(w http.ResponseWriter, r *http.Request) {
	 //pfx私钥
	 privatepfxpath, pfxerr := filepath.Abs("src/payease_icccashier/package/client.pfx")
	 if pfxerr != nil {  
	    fmt.Println("pfxerr:", pfxerr)  
	 } 
	 pfxpwd := "123456"
     //cer公钥
	 publiccerpath, cererr := filepath.Abs("src/payease_icccashier/package/payease.cer")
	 if cererr != nil {  
	    fmt.Println("cererr:", cererr)  
	 }
	 r.ParseForm()
	 rpencryptKey := utils.IsNull(r.Header["Encryptkey"])
     if rpencryptKey != "" {		
		aeskey,err := utils.PrivateDecrypt(rpencryptKey, privatepfxpath, pfxpwd)
		if err != nil {
		  fmt.Println("perr:", err)
	   }	
		body, err := ioutil.ReadAll(r.Body)
	   if err != nil {
	     fmt.Println("berr:", err)
	   }  
	   var rback utils.ResponseBack
       json.Unmarshal(body, &rback)
	   ret,err := utils.AesECBDecrypt(rback.Data,aeskey)
	   if err != nil {
		  fmt.Println("aerr:", err)
	   }
	   var orderbacks models.RefuseBack
		json.Unmarshal([]byte(ret), &orderbacks)
		rhmac := orderbacks.Hmac
		//fmt.Println("rhmac:", rhmac)
		if 	rhmac != ""{
			sortdeldata, oerr := utils.GetDelJson(string(ret),"hmac")
			if oerr != nil {
				fmt.Println("oerr:", oerr)
			} 
			signhm := utils.Sha1(sortdeldata)
			verr := utils.VerifySign(signhm ,publiccerpath,rhmac)
			if verr == nil {
				fmt.Fprintf(w, "SUCCESS")
				fmt.Println("拒付通知：SUCCESS")
				fmt.Println("ret:", ret)
			}else{
				fmt.Println("verr:", verr)
			}
		}else{
			fmt.Println("response:", ret)
			fmt.Fprintf(w, "拒付通知异常\n"+ ret)
		}
	}else{
		fmt.Println("NO Data")
	}  
	 return
}